﻿using ProjectTank.DrawningObjects;
using ProjectTank.Entities;

namespace ProjectTank.Generics
{
    internal class TankCompareByColor : IComparer<DrawningTankBase?>
    {
        public int Compare(DrawningTankBase? x, DrawningTankBase? y)
        {
            if (x == null || x.EntityTankBase == null)
                throw new ArgumentNullException(nameof(x));

            if (y == null || y.EntityTankBase == null)
                throw new ArgumentNullException(nameof(y));
            
            if (x.EntityTankBase.BodyColor.Name != y.EntityTankBase.BodyColor.Name)
            {
                return x.EntityTankBase.BodyColor.Name.CompareTo(y.EntityTankBase.BodyColor.Name);
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                if (x is DrawningTankBase) return -1;
                else return 1;
            }
            if (x.GetType().Name == y.GetType().Name && x is DrawningTank)
            {
                EntityTank EntityX = (EntityTank)x.EntityTankBase;
                EntityTank EntityY = (EntityTank)y.EntityTankBase;
                if (EntityX.AdditionalColor.Name != EntityY.AdditionalColor.Name)
                {
                    return EntityX.AdditionalColor.Name.CompareTo(EntityY.AdditionalColor.Name);
                }
            }
            var speedCompare = x.EntityTankBase.Speed.CompareTo(y.EntityTankBase.Speed);

            if (speedCompare != 0)
                return speedCompare;

            return x.EntityTankBase.Weight.CompareTo(y.EntityTankBase.Weight);
        }
    }
}