﻿using ProjectTank.DrawningObjects;

namespace ProjectTank.Generics
{
    internal class TankCompareByType : IComparer<DrawningTankBase?>
    {
        public int Compare(DrawningTankBase? x, DrawningTankBase? y)
        {
            if (x == null || x.EntityTankBase == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityTankBase == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare = x.EntityTankBase.Speed.CompareTo(y.EntityTankBase.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return x.EntityTankBase.Weight.CompareTo(y.EntityTankBase.Weight);
        }
    }
}
